**free                                                                                              
                                                                                                    
// RPG BATTLE DEV 2023 - Manche 1 - Epreuve 2 - Du 7 au 9 juin 2023                                 
                                                                                                    
// Contexte :                                                                                       
//  Définition : un palindrome est un mot qui peut se lire dans les 2 sens. Exemple : radar         
//  Le fichier base de données TEAMLIB/MOTS contient une liste de mots (1 mot par enregistrement)   
                                                                                                    
// Objectif :                                                                                       
//  Afficher le nombre de palindromes présents et les afficher (DSPLY) par ordre alphabétique       
//  Exemple de résultat :                                                                           
//   DSPLY 2                                                                                        
//   DSPLY abcba                                                                                    
//   DSPLY radar                                                                                    
                                                                                                    
// Consignes :                                                                                      
//  1. Ne pas modifier les lignes de code déjà présentes, ajouter vos lignes de code nécessaires    
//  2. Utiliser uniquement des instructions RPG natives (pas de SQL, pas d'appels d'API ...)        
//  3. Dans le fichier MOTS :                                                                       
//     - Ne pas tenir compte des espaces et des ponctuations                                        
//     - Considérer les caractères accentués comme leurs caractères de base (é => e, ç => c)        
//  4. En cas de doublon, n'afficher qu'une seule occurrence du mot                                 
                                                                                                    
// Critères d'évaluation :                                                                          
//  1. Le résultat doit être celui demandé                                                          
//  2. Le code présent ne doit pas être modifié                                                     
//  3. Le code doit être le plus simple, le plus lisible possible et le plus optimisé               
//  4. Le programme doit s'appeler E2 dans votre bibliothèque TEAMxx                                
                                                                                                    
// ------------------------------------------------------------------------------------------------ 
// Votre profil IBM i : TEAMxx                                                                      
// ------------------------------------------------------------------------------------------------ 
                                                                                                    
ctl-opt actgrp(*new) alwnull(*no);                                                                  
                                                                                                    
dcl-f mots rename(mots:fmots);                                                                      
                                                                                                    
// Parcours du fichier                                                                              
read fmots ;                                                                                        
dow not %eof( mots ) ;                                                                              
  read fmots ;                                                                                      
enddo ;                                                                                             
                                                                                                    
return ;                                                                                            
