**free                                                                                              
                                                                                                    
// RPG BATTLE DEV 2023 - Manche 2 - Epreuve 4 - Du 14 au 16 juin 2023                               
                                                                                                    
// Contexte :                                                                                       
//  - Un fichier CSV contient des données séparées par le caractère ;                               
//  - Un fichier JSON contient des données représentées sous forme de paires clés/valeurs           
//    contenues dans un objet : {"code": "valeur du code", "prix": 12}                              
//  - Un tableau JSON est matérialisé par [ valeur1, valeur2... ] valeurx étant un objet JSON       
//    Exemple : [{"p1": "peinture bleue", "prix": 10}, {"p2": "peinture verte", "prix": 9.5}]       
                                                                                                    
// Objectif :                                                                                       
//  Depuis le fichier base de données (TEAMLIB/INFOS) contenant des données au format CSV,          
//  construire la valeur JSON correspondante dans la variable JSONVAR                               
                                                                                                    
// Exemple :                                                                                        
// - Le fichier INFOS fourni contient les lignes suivantes :                                        
//    nom;prenom;compagnie                                                                          
//    Gates;Bill;Microsoft                                                                          
//    Soltis;Frank;IBM                                                                              
//    Jobs;Steve;Apple                                                                              
// - Vous devez construire la chaîne JSON suivante :                                                
//   JSONVAR => [{"nom": "Gates", "prenom": "Bill", "compagnie": "Microsoft"},                      
//               {"nom": "Soltis", "prenom": "Frank", "compagnie": "IBM"},                          
//               {"nom": "Jobs", "prenom": "Steve", "compagnie": "Apple"}]                          
// - Envoyez la valeur de JSONVAR en tant que message dans la JOBLOG (SND-MSG)                      
                                                                                                    
// Consignes :                                                                                      
//  1. Ne pas modifier les lignes de code déjà présentes, ajouter vos lignes de code nécessaires    
//  2. Utiliser uniquement des instructions RPG natives (pas de SQL, pas d'appels d'API ...)        
//  3. Lorsqu'une valeur n'est pas alimentée dans le fichier INFOS (nom, prénom ou compagnie),      
//     indiquer : "*** Inconnu ***" (avec les caractères ")                                         
//  4. Certains caractères nécessitent un traitement spécial en JSON :                              
//     cf https://www.json.org/json-fr.html                                                         
                                                                                                    
// Critères d'évaluation :                                                                          
//  1. Le résultat doit être celui demandé                                                          
//  2. Le code présent ne doit pas être modifié                                                     
//  3. Le code doit être le plus simple, le plus lisible et le plus optimisé                        
//  4. Le programme doit s'appeler E4 dans votre bibliothèque TEAMxx                                
                                                                                                    
                                                                                                    
// ------------------------------------------------------------------------------------------------ 
// Votre profil IBM i : TEAMxx                                                                      
// ------------------------------------------------------------------------------------------------ 
                                                                                                    
ctl-opt actgrp(*new) alwnull(*no);                                                                  
                                                                                                    
dcl-f infos ;                                                                                       
dcl-s JSONVAR varchar(100000) inz ;                                                                 
                                                                                                    
read infof ;                                                                                        
                                                                                                    
return ;                                                                                            
